/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   lm_parser.c                                        :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: mndhlovu <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/03/25 06:30:51 by mndhlovu          #+#    #+#             */
/*   Updated: 2019/03/25 06:30:57 by mndhlovu         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "lem_in.h"

static void         lm_locate_cmd(int count, char *raw, t_syntax *synt)
{
    int                 s_state;
    int                 e_state;
    char                *tmp;
    int                 index;

    index = 0;
    s_state = synt->s_cmd;
    e_state = synt->e_cmd;
    tmp = ft_strchr(raw, '#');
    if ((!s_state || !e_state) && (tmp != NULL && raw[index + 1] == '#'))
    {
        if (!s_state)
        {
            if (ft_strcmp(tmp, "##start"))
            {
                synt->s_cmd = 1;
                synt->e_pos = count;
            }
        }
        if (!e_state)
        {
            if (ft_strcmp(tmp, "##end"))
            {
                synt->e_cmd = 1;
                synt->s_pos = count;
            }
        }
    }
}

static void         lm_get_vertices(int count, char *raw, t_syntax *synt,
                        t_lmdata *data, t_graph *graph)
{
    int                 index;
    char                *tmp;
    char                *tmp2;
    int                 value;

    index = 0;
    value = 0;
    graph = NULL;
    if (synt->s_cmd > 0 && (synt->e_pos == count - 1))
    {
        synt->s_vert = count;
        lm_add_vertex(data, raw, 's');
    }
    if (synt->e_cmd > 0 && (synt->s_pos == count - 1))
    {
        synt->e_vert = count;
        lm_add_vertex(data, raw, 'e');
    }
    if (count > 0 && (count != synt->s_vert && count != synt->e_vert)
            && (count != synt->s_pos && count != synt->e_pos))
    {
        tmp = ft_strchr(raw, '-');
        tmp2 = ft_strchr(raw, '#');
        if (tmp == NULL && tmp2 == NULL)
            lm_add_vertex(data, raw, 'v');
        else if (tmp2 == NULL && tmp != NULL)
        {
            lm_ext_conn(graph, data, raw, synt);
        }
    }
}

static void         lm_get_ant_num(int count, char *raw, t_lmdata *ldata, t_syntax *synt)
{
    int             index;
    int             value;

    index = 0;
    if (count == 0)
    {
        if (!ft_isdigit(raw[index + 1]))
        {
            value = raw[index] - '0';
            ldata->nbants = (value > 0) ? value : 0;
            synt->nb_state = 1;
        }
        if (ft_isdigit(raw[index + 1]))
        {
            ldata->nbants = (ft_atoi(raw) > 0) ? ft_atoi(raw) : 0;
            synt->nb_state = 1;
        }
    }
}


int                 lm_parser(int fd, t_syntax *synt, t_lmdata *ldata,
                    t_graph *graph)
{
    char            *raw;
    int             ret;
    int             index;

    index = 0;
    ft_printf("debug flags %d \n", index);
    while ((ret = get_next_line(fd, &raw)))
    {
        if (ret == -1)
            return (0);
        lm_get_ant_num(index, raw, ldata, synt);
        lm_locate_cmd(index, raw, synt);
        lm_get_vertices(index, raw, synt, ldata, graph);
        index++;
    }
    if (index > 1)
        return (1);
    return (0);
}